
*  1/16/98 Chris Falk, George Baker - revised J1A PRGcode - took outMOR
*                programming, added finished flag at end of code.

PORTA    EQU    $00
DDRA     EQU    $04
EPROG    EQU    $18
PRGSUB   EQU    $C0
VRFSUB   EQU    $D3
PRBYTE   EQU    $C3
IADDH    EQU    $C5
IADDL    EQU    $C6
LENGTH   EQU    $EA
USRCD    EQU    $0400
PRGFLG   EQU    $03E9


         ORG    $300
MAIN
         LDA    PRGFLG             ;IF LAST BYTE OF PRG CODE IS BLANK, PART
                                   ; HAS NOT BEEN PROGRAMMED.
         BEQ    ICP               ;START DOWNLOADING.
         JMP    USRCD             ;IF NOT, EXECUTE CODE
ICP
         LDA    #$06              ;APPLY VPP AND TURN OFF
         STA    DDRA              ;"FINISHED" LED
         STA    PORTA
         LDX    #$2A              ;CONTAINS # OF BYTES TO MOVE TO RAM
MV2RAM
         LDA    PRGRT-1,X         ;MOVE PROGRAM AND VERIFY
         STA    PRGSUB-1,X        ;ROUTINES TO RAM
         DECX
         BNE    MV2RAM            ;ALL MOVED?
SLOAD
         BSR    SCIRX             ;GET FIRST CHARACTER
         CMP    #'S'              ;IS IT S?
         BNE    SLOAD             ;NO, WAIT FOR S
         BSR    SCIRX             ;YES, GET NEXT CHARACTER
         CMP    #'1'              ;IS IT 1?
         BNE    DONE              ;NO, S RECORD IS FINISHED
         BSR    RCVASC            ;YES, GET LENGTH OF RECORD
         SUB    #$02              ;SUBTRACT ADDRESS BYTES
         STA    LENGTH            ;STORE IT FOR LATER USE
         BSR    RCVASC            ;GET UPPER ADDRESS
         STA    IADDH             ;OF RECORD START
         BSR    RCVASC            ;GET LOWER ADDRESS
         STA    IADDL             ;OF RECORD START
         BRA    LPSTRT            ;GO!
SLOOP
         LDA    #$02              ;TOGGLE LED
         EOR    PORTA
         STA    PORTA
         LDA    IADDL             ;IS ADDRESS TO BE
         CMP    #$F1              ;PROGRAMMED $7F1(MOR)?
         BNE    NOTMOR            ;YES, SET MPGM INSTEAD OF
         LDA    IADDH             ;EPGM IN PRGSUB
         CMP    #$07              ;NO, CONTINUE AS NORMAL
         BNE    NOTMOR
         JMP    SKIPMOR
NOTMOR
         JSR    PRGSUB            ;GOTO PROGRAMMING SUBROUTINE IN RAM
         BCLR   1,$C7
         LDA    IADDH             ;MOVE ADDRESS TO VERIFY
         STA    $D6               ;SUBROUTINE IN RAM
         LDA    IADDL
         STA    $D7
         JSR    VRFSUB           ;VERIFY THAT BYTE PROGRAMMED CORRECTLY
SKIPMOR                          ;SKIP, WE DONT WANT TO PROGRAM THE MOR
         JSR    INCADDR           ;MOVE TO NEXT ADDRESS
LPSTRT
         JSR    RCVASC            ;GET NEXT BYTE
                                  ;(TAKES INTO ACCOUNT CHKSM |)
         DEC    LENGTH            ;S-RECORD FINISHED?
         BNE    SLOOP             ;NO, PROGRAM BYTE
         BRA    SLOAD             ;YES, GET NEXT S-RECORD
DONE
         LDA    #$03
         STA    PRBYTE
         STA    IADDH
         LDA    #$E9
         STA    IADDL
         JSR    PRGSUB
         CLR    PORTA             ;TURN OFF VPP, TURN ON FINISHED LED
         BRA    *
SCIRX
         BRSET  0,PORTA,*         ;WAIT FOR START BIT
         BSR    DLY378            ;DELAY 2500 CYCLES TO BE IN MIDDLE
         BSR    DLY378            ;OF TRANSMITTED BIT (1200 BAUD)
         BSR    DLY42
         CLRA                     ;OF TRANSMITTED BIT
         SEC                      ;CARRY IS USED AS STOP BIT
RX1
         BCS    RX2               ;BURN A COUPLE CYCLES
         BRSET  0,PORTA,RX2       ;BRSET SETS/CLEARS CARRY
RX2                               ;DEPENDING ON EVALUATION
         LDX    #$04
WAIT
         BSR    DLY378            ;THIS LOOP BURNS 1560 CYLES
         DECX                     ;TOTAL CYCLES BETWEEN BITS
         BNE    WAIT              ;IS 1672
         BSR    DLY90
         RORA                     ;MOVE CARRY BIT DOWN ACCUMULATOR
         BCC    RX1               ;REPEAT UNTIL STOP BIT REACHES CARRY
         BRCLR  0,PORTA,FRMERR
FRMERR
         RTS                      ;DONE WITH THAT ASCII BYTE
RCVASC
         BSR    GETASC            ;GET NIBBLE OF BYTE
         BCS    GOTCR             ;SKIP IF CONTROL CHAR
         BSR    SHIFT4            ;MOVE LOWER NIBBLE TO UPPER
         STA    PRBYTE            ;NIBBLE AND STORE FOR LATER USE
         BSR    GETASC            ;GET THE OTHER NIBBLE
         BCS    GOTCR             ;SKIP IF CONTROL CHAR
         ORA    PRBYTE            ;COMBINE LOWER NIBBLE WITH
         STA    PRBYTE
         RTS                      ;UPPER NIBBLE TO MAKE A BYTE
GETASC
         BSR    SCIRX             ;GO GET A CHARACTER
         CMP    #'0'              ;LESS THAN 0?
         BLO    GOTCR             ;YES, ITS A CONTROL CHAR
         CMP    #'A'              ;NO, LESS THAN A?
         BLO    ONENINE           ;YES, CONTINUE AS NORMAL
         SUB    #$07              ;NO, CONVERT TO HEX
ONENINE
         AND    #$0F              ;MASK OFF UPPER NIBBLE
         CLC
GOTCR
         RTS
SHIFT4
         LDX    #$10              ;MOVE LOWER NIBBLE
         MUL                      ;TO UPPER NIBBLE
         RTS
INCADDR
         INC    IADDL             ;INCREMENT LOWER ADDRESS
         BNE    RETURN            ;EQUAL TO 00? NO, RETURN
         INC    IADDH             ;YES, BUMP HIGH ADDRESS
RETURN
         RTS
PRGRT
         BSET   2,EPROG           ;SET ELAT
         LDA    #PRBYTE            ;STORE DESIRED BYTE
         STA    $0400             ;TO DESIRED LOCATION
         BSET   0,EPROG           ;SET EPGM
         LDX    #$03              ;DELAY 3X378 CYCLES
DLYLP
         BSR    DLY378
         DECX
         BNE    DLYLP
         CLR    EPROG             ;CLEAR ELAT AND EPGM
         RTS                      ;DONE
VRFRT
         LDA    PRBYTE            ;COMPARE VALUE TO BE PROGRAMMED
         CMP    $0400             ;WITH ACTUAL PROGRAMMED VALUE
         BEQ    PASS              ;ARE THEY =?
         BSET   1,PORTA           ;NO TURN OFF LED
FAIL
         BRA    *                 ;AND HANG
PASS
         RTS                      ;YES, GO ON
DLY378   BSR    DLY186
DLY186   BSR    DLY90
DLY90    BSR    DLY42
DLY42    BSR    DLY18
DLY18    BSR    DLY6
DLY6     RTS

         ORG    $7FE
RESET
         DW     $0300
